/*
 * Copyright (C) 2021. Huawei Technologies Co., Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef LIBSTORAGE_STAT_H
#define LIBSTORAGE_STAT_H

#include "spdk/stdinc.h"

/* share memory file name */
#define LIBSTORAGE_STAT_SHM_FILE_NAME   "libstorage_stat.shm.\
49ce4ec241e017c65812b71b9832a50865f0b7d9b4d5f18d3d03283b"

/* max number of channel+bdev */
#define STAT_MAX_NUM 8192

extern int32_t g_libstorage_iostat;
extern int32_t g_polltime_threshold;

extern pthread_mutex_t *g_io_stat_map_mutex;

/* libstorage iostat status */
enum libstorage_iostat_status {
	LIBSTORAGE_IOSTAT_DISABLE = 0,
	LIBSTORAGE_IOSTAT_ENABLE  = 1,
	LIBSTORAGE_IOSTAT_QUERY  = 2,
};

struct libstorage_bdev_io_stat {
	bool used;
	uint16_t channel_id;
	char bdev_name[24];
	uint64_t num_read_ops;
	uint64_t num_write_ops;
	uint64_t bytes_read;
	uint64_t bytes_written;
	uint64_t io_outstanding;
	uint64_t read_latency_ticks;
	uint64_t write_latency_ticks;
	uint64_t io_ticks;
	bool poll_time_used;
	uint64_t num_poll_timeout;
};

extern struct libstorage_bdev_io_stat *g_io_stat_map;

int libstorage_stat_init(void);

int libstorage_stat_exit(void);
#endif
